function RandomizeTraining_Kavraki()
    load('Kavraki_data.mat');
    
    % Where we will originally store the processed data
    cartesianLabels_F1=pos{1,1};
    cartesianLabels_F2=pos{2,1};
    cartesianLabels_F3=pos{3,1};
    MacIndices=ap;
    Data_F1=sir{1,1};
    Data_F2=sir{2,1};
    Data_F3=sir{3,1};
    
    % Any AP that was not seen (value of NaN) is set to 0
    Data_F1(isnan(Data_F1))=0;
    Data_F2(isnan(Data_F2))=0;
    Data_F3(isnan(Data_F3))=0;
    
    % Stores the number of different locations in the training data
    numLoc_F1=size(cartesianLabels_F1,1);
    numLoc_F2=size(cartesianLabels_F2,1);
    numLoc_F3=size(cartesianLabels_F3,1);
    
    % Stores the number of data points, for each location
    dataPerLoc_F1=size(Data_F1,1)/numLoc_F1;
    dataPerLoc_F2=size(Data_F2,1)/numLoc_F2;
    dataPerLoc_F3=size(Data_F3,1)/numLoc_F3;
    
    for n=1:50
        n
        for i=1:1:20 % Get data with 1 to 20 scans per location
            % Setup our training data array
            trainingSamplesPerClass_F1 = floor(dataPerLoc_F1*i/100);
            classificationSamplesPerClass_F1 = ceil(dataPerLoc_F1*(100-i)/100);
            trainingData_F1 = zeros(numLoc_F1*trainingSamplesPerClass_F1, size(Data_F1,2));
            classificationData_F1 = zeros(numLoc_F1*classificationSamplesPerClass_F1, size(Data_F1,2));
            trainingLabels_F1 = zeros(numLoc_F1*trainingSamplesPerClass_F1, 1);
            classificationLabels_F1=zeros(numLoc_F1*classificationSamplesPerClass_F1, 1);
            
            trainingSamplesPerClass_F2 = floor(dataPerLoc_F2*i/100);
            classificationSamplesPerClass_F2 = ceil(dataPerLoc_F2*(100-i)/100);
            trainingData_F2 = zeros(numLoc_F2*trainingSamplesPerClass_F2, size(Data_F2,2));
            classificationData_F2 = zeros(numLoc_F2*classificationSamplesPerClass_F2, size(Data_F2,2));
            trainingLabels_F2 = zeros(numLoc_F2*trainingSamplesPerClass_F2, 1);
            classificationLabels_F2=zeros(numLoc_F2*classificationSamplesPerClass_F2, 1);
            
            trainingSamplesPerClass_F3 = floor(dataPerLoc_F3*i/100);
            classificationSamplesPerClass_F3 = ceil(dataPerLoc_F3*(100-i)/100);
            trainingData_F3 = zeros(numLoc_F3*trainingSamplesPerClass_F3, size(Data_F3,2));
            classificationData_F3 = zeros(numLoc_F3*classificationSamplesPerClass_F3, size(Data_F3,2));
            trainingLabels_F3 = zeros(numLoc_F3*trainingSamplesPerClass_F3, 1);
            classificationLabels_F3=zeros(numLoc_F3*classificationSamplesPerClass_F3, 1);
            
            % Loop through all the test cases selecting random samples
            for j=1:numLoc_F1
                % Set up training samples
                r=randperm(dataPerLoc_F1)+(j-1)*dataPerLoc_F1;
                trainingData_F1((((j-1)*trainingSamplesPerClass_F1)+1):(j*trainingSamplesPerClass_F1),:) = Data_F1(r(1:trainingSamplesPerClass_F1),:);  
                classificationData_F1((((j-1)*classificationSamplesPerClass_F1)+1):(j*classificationSamplesPerClass_F1),:) = Data_F1(r(trainingSamplesPerClass_F1+1:size(r,2)),:);  
                trainingLabels_F1((((j-1)*trainingSamplesPerClass_F1)+1):(j*trainingSamplesPerClass_F1),:) = j;  
                classificationLabels_F1((((j-1)*classificationSamplesPerClass_F1)+1):(j*classificationSamplesPerClass_F1),:) = j;
            end
            
            for j=1:numLoc_F2
                % Set up training samples
                r=randperm(dataPerLoc_F2)+(j-1)*dataPerLoc_F2;
                trainingData_F2((((j-1)*trainingSamplesPerClass_F2)+1):(j*trainingSamplesPerClass_F2),:) = Data_F2(r(1:trainingSamplesPerClass_F2),:);  
                classificationData_F2((((j-1)*classificationSamplesPerClass_F2)+1):(j*classificationSamplesPerClass_F2),:) = Data_F2(r(trainingSamplesPerClass_F2+1:size(r,2)),:);  
                trainingLabels_F2((((j-1)*trainingSamplesPerClass_F2)+1):(j*trainingSamplesPerClass_F2),:) = j;  
                classificationLabels_F2((((j-1)*classificationSamplesPerClass_F2)+1):(j*classificationSamplesPerClass_F2),:) = j;
            end
            
            for j=1:numLoc_F3
                % Set up training samples
                r=randperm(dataPerLoc_F3)+(j-1)*dataPerLoc_F3;
                trainingData_F3((((j-1)*trainingSamplesPerClass_F3)+1):(j*trainingSamplesPerClass_F3),:) = Data_F3(r(1:trainingSamplesPerClass_F3),:);  
                classificationData_F3((((j-1)*classificationSamplesPerClass_F3)+1):(j*classificationSamplesPerClass_F3),:) = Data_F3(r(trainingSamplesPerClass_F3+1:size(r,2)),:);  
                trainingLabels_F3((((j-1)*trainingSamplesPerClass_F3)+1):(j*trainingSamplesPerClass_F3),:) = j;  
                classificationLabels_F3((((j-1)*classificationSamplesPerClass_F3)+1):(j*classificationSamplesPerClass_F3),:) = j;
            end

            filename = strcat('Kavraki/TrainingRandomized/Trained_', num2str(i,'%02d'), '_', num2str(n,'%02d'), '.mat');
            save(filename, 'trainingData_F1', 'trainingLabels_F1', 'classificationData_F1', 'classificationLabels_F1', 'cartesianLabels_F1','trainingData_F2', 'trainingLabels_F2', 'classificationData_F2', 'classificationLabels_F2', 'cartesianLabels_F2','trainingData_F3', 'trainingLabels_F3', 'classificationData_F3', 'classificationLabels_F3', 'cartesianLabels_F3', 'MacIndices');
        end  
    end
end
