function RandomizeTraining_RealRobot(onlyUCM)   
    % If nothing was passed as a parameter, we only use UCM networks
    if(nargin<1)
        onlyUCM = 1;
    end    

    % Load a previously-saved file, so that we can get the Mac Indices
    if(onlyUCM)
        load('/home/webenji/src/ResearchSoftware/WifiLocalization/DataCollection/GorkemUCM/TrainingRandomized/Trained_05_01.mat', 'MacIndices');
    else
        load('/home/webenji/src/ResearchSoftware/WifiLocalization/DataCollection/GorkemAll/TrainingRandomized/Trained_05_01.mat', 'MacIndices');
    end
    
    % Load the data collected for the real robot
    load('RealRobot_data.mat', 'data', 'locs');
    
    Data=zeros(1,size(MacIndices,1));
    % Get unique indexes for the MAC addresses
    for i=1:size(data,1) 
        for j=1:size(data(i,1).ap,1)
            % Make sure Mac Adress is part of our list
            %size(strmatch(data(i,1).ap(j,1).mac, MacIndices, 'exact'),1)
            if(size(strmatch(data(i,1).ap(j,1).mac, MacIndices, 'exact'),1)~=0)                
                Data(i, strmatch(data(i,1).ap(j,1).mac, MacIndices, 'exact')) = data(i,1).ap(j,1).signal;
            end
        end
    end
    
    % Any AP that was not seen (value of 0) is set to -100
    Data(Data==0)=-100;
    
    % Stores the number of different locations in the training data
    numLoc=size(locs,1);
    
    % Stores the number of data points, for each location
    dataPerLoc=size(Data,1)/numLoc;
    
    % Save the 10 "robot paths"
    for i=1:10
        classificationLabels=locs;
        classificationData=Data(i:10:size(Data,1),:);
        save(strcat('RealRobot/Runs/',num2str(i,'%02d'),'.mat'), 'classificationData', 'classificationLabels', 'MacIndices');
    end
end
