clear all
close all

numReadings=3;
j=numReadings*5;

classificationOnly_RForest=zeros(50,10);
classificationOnly_Gaussian=zeros(50,10);
classificationOnly_SVM=zeros(50,10);
classificationOnly_NNS=zeros(50,10);
gmm_RF=zeros(50,10);
gmm_NN=zeros(50,10);

for n=1:50
    for k=1:10
        n
        k
        %% Load Data
        load(strcat('RealRobot/Runs/',num2str(k,'%02d'),'.mat'), 'classificationData', 'classificationLabels', 'MacIndices');

        filename = strcat('GorkemUCM/TrainingRandomized/Trained_', num2str(j,'%02d'), '_', num2str(n,'%02d'), '.mat');
        load(filename, 'cartesianLabels', 'trainingData', 'trainingLabels');
        filename = strcat('GorkemUCM/RandomForest/trained_', num2str(j,'%02d'), '_', num2str(n,'%02d'), '.mat');
        load(filename, 'rForest');
        filename = strcat('GorkemUCM/GaussianMixtureKavraki/trained_', num2str(j,'%02d'), '_', num2str(n,'%02d'), '.mat');
        load(filename, 'Gaussians', 'trainingTime');
        filename = strcat('GorkemUCM/SVMoneVall/Trained_', num2str(j,'%02d'), '_', num2str(n,'%02d'), '.mat');
        load(filename, 'xsup','w','b','nbsv','kernel','kerneloption');
        filename = strcat('GorkemUCM/LRoneVall/trained_', num2str(j,'%02d'), '_', num2str(n,'%02d'), '.mat');
        load(filename, 'B');


        %% Random Forest Classification
        gdiErrorPlotX=[];
        gdiErrorPlotY=[];

        [yPredicted, scores] = predict(rForest, classificationData);

        yfit=str2double(yPredicted);

        D=0.3048*sqrt(sum((cartesianLabels(yfit,:)-classificationLabels).^2,2));
        classificationOnly_RForest(n,k) = mean(D);

        % var=size(gdiErrorPlotY,1)+1;
        % for i=1:ceil(max(D))*4+1
        %     gdiErrorPlotY(var,i)=sum(D<=0.25*(i-1))/size(classificationLabels,1);
        % end
        % 
        % % Clean up array to remove extra zeros
        % for i=1:size(gdiErrorPlotY,1)
        %     indices = find(gdiErrorPlotY(i,:)==1);
        %     gdiErrorPlotY(i,indices(size(indices,2)):size(gdiErrorPlotY,2))=1;
        % end
        % 
        % figure
        % 
        % gdiErrorPlotX = 0:0.25:(size(gdiErrorPlotY,2)-1)/4;
        % 
        % % If we only have one dataset
        % if(size(gdiErrorPlotY,1)==1)
        %     plot(gdiErrorPlotX, gdiErrorPlotY, 'k');
        % else
        %     plot(gdiErrorPlotX, mean(gdiErrorPlotY), 'k');
        % end

        %% Gaussian Mixture Classification
        numLoc=size(cartesianLabels,1);
        params=size(trainingData,2);

        Mean=Gaussians(:,1:2:size(Gaussians,2));
        Mean=reshape(Mean', 1, size(Mean,1)*size(Mean,2))';
        Var=Gaussians(:,2:2:size(Gaussians,2));
        Var=reshape(Var', 1, size(Var,1)*size(Var,2))';

        tic;
        yfit = zeros(size(classificationData,1),size(Gaussians,1));
        for ex=1:size(classificationData,1) % Loop through all examples
            exToClassify=repmat(classificationData(ex,:),1,numLoc)';


            exResults = normpdf(exToClassify, Mean, Var);

            %exResults(Var==0 & exToClassify==Mean)=normpdf(-95,-95,1);
            exResults(Var==0 & exToClassify==Mean)=1;
            exResults(Var==0 & exToClassify~=Mean)=0.00001;
            exResults(exToClassify==-100)=1;
            %exResults(Mean==-100)=1;                


            exResults(exResults<0.00001)=0.00001;
            exResults = reshape(exResults,params,numLoc)';
            yfit(ex,:)=prod(exResults,2)';
        end

        [R, I] = max(yfit');
        D=0.3048*sqrt(sum((cartesianLabels(I,:)-classificationLabels).^2,2));
        classificationOnly_Gaussian(n,k) = mean(D);

        % var=size(gdiErrorPlotY,1)+1;
        % for i=1:ceil(max(D))*4+1
        %     gdiErrorPlotY(var,i)=sum(D<=0.25*(i-1))/size(classificationLabels,1);
        % end
        % 
        % % Clean up array to remove extra zeros
        % for i=1:size(gdiErrorPlotY,1)
        %     indices = find(gdiErrorPlotY(i,:)==1);
        %     gdiErrorPlotY(i,indices(size(indices,2)):size(gdiErrorPlotY,2))=1;
        % end
        % 
        % hold on
        % 
        % gdiErrorPlotX = 0:0.25:(size(gdiErrorPlotY,2)-1)/4;
        % 
        % % If we only have one dataset
        % if(size(gdiErrorPlotY,1)==1)
        %     plot(gdiErrorPlotX, gdiErrorPlotY, 'm');
        % else
        %     plot(gdiErrorPlotX, mean(gdiErrorPlotY), 'm');
        % end

        %% SVM Classification
        numLoc=size(cartesianLabels,1);
        params=size(trainingData,2);

        [yfit,maxi,ypredMat] = svmmultival(classificationData,xsup,w,b,nbsv,kernel,kerneloption);

        D=0.3048*sqrt(sum((cartesianLabels(yfit,:)-classificationLabels).^2,2));
        classificationOnly_SVM(n,k) = mean(D);

        % var=size(gdiErrorPlotY,1)+1;
        % for i=1:ceil(max(D))*4+1
        %     gdiErrorPlotY(var,i)=sum(D<=0.25*(i-1))/size(classificationLabels,1);
        % end
        % 
        % % Clean up array to remove extra zeros
        % for i=1:size(gdiErrorPlotY,1)
        %     indices = find(gdiErrorPlotY(i,:)==1);
        %     gdiErrorPlotY(i,indices(size(indices,2)):size(gdiErrorPlotY,2))=1;
        % end
        % 
        % hold on
        % 
        % gdiErrorPlotX = 0:0.25:(size(gdiErrorPlotY,2)-1)/4;
        % 
        % % If we only have one dataset
        % if(size(gdiErrorPlotY,1)==1)
        %     plot(gdiErrorPlotX, gdiErrorPlotY, 'b');
        % else
        %     plot(gdiErrorPlotX, mean(gdiErrorPlotY), 'b');
        % end

        %% NNS Classification
        yfit=[];
        numLoc=size(cartesianLabels,1);

        yfit = knnclassify(classificationData, trainingData, trainingLabels);

        D=0.3048*sqrt(sum((cartesianLabels(yfit,:)-classificationLabels).^2,2));
        classificationOnly_NNS(n,k) = mean(D);

        % var=size(gdiErrorPlotY,1)+1;
        % for i=1:ceil(max(D))*4+1
        %     gdiErrorPlotY(var,i)=sum(D<=0.25*(i-1))/size(classificationLabels,1);
        % end
        % 
        % % Clean up array to remove extra zeros
        % for i=1:size(gdiErrorPlotY,1)
        %     indices = find(gdiErrorPlotY(i,:)==1);
        %     gdiErrorPlotY(i,indices(size(indices,2)):size(gdiErrorPlotY,2))=1;
        % end
        % 
        % hold on
        % 
        % gdiErrorPlotX = 0:0.25:(size(gdiErrorPlotY,2)-1)/4;
        % 
        % % If we only have one dataset
        % if(size(gdiErrorPlotY,1)==1)
        %     plot(gdiErrorPlotX, gdiErrorPlotY, 'y');
        % else
        %     plot(gdiErrorPlotX, mean(gdiErrorPlotY), 'y');
        % end

        %% Random Forest GMM Regression
        gdiErrorPlotX=[];
        gdiErrorPlotY=[];

        [yPredicted, scores] = predict(rForest, classificationData);

        scores2 = repmat(scores,2,1);

        scores3=[];
        for l=1:size(scores2,1)/2
            scores3=[scores3; scores2(l:size(scores,1):size(scores2,1),:)];
        end

        cartesianLabels2=repmat(cartesianLabels,1,size(scores,1));

        C=dot(scores3',cartesianLabels2);

        yfit = reshape(C, 2, size(C,2)/2)';

        D=0.3048*sqrt(sum((yfit-classificationLabels).^2,2));
        gmm_RF(n,k) = mean(D);            

        % var=size(gdiErrorPlotY,1)+1;
        % for i=1:ceil(max(D))*4+1
        %     gdiErrorPlotY(var,i)=sum(D<=0.25*(i-1))/size(classificationLabels,1);
        % end
        % 
        % % Clean up array to remove extra zeros
        % for i=1:size(gdiErrorPlotY,1)
        %     indices = find(gdiErrorPlotY(i,:)==1);
        %     gdiErrorPlotY(i,indices(size(indices,2)):size(gdiErrorPlotY,2))=1;
        % end
        % 
        % hold on
        % 
        % gdiErrorPlotX = 0:0.25:(size(gdiErrorPlotY,2)-1)/4;
        % 
        % % If we only have one dataset
        % if(size(gdiErrorPlotY,1)==1)
        %     plot(gdiErrorPlotX, gdiErrorPlotY, 'g');
        % else
        %     plot(gdiErrorPlotX, mean(gdiErrorPlotY), 'g');
        % end


        %% Gaussian Mixture GMM Regression
        % numLoc=size(cartesianLabels,1);
        % params=size(trainingData,2);
        % 
        % Mean=Gaussians(:,1:2:size(Gaussians,2));
        % Mean=reshape(Mean', 1, size(Mean,1)*size(Mean,2))';
        % Var=Gaussians(:,2:2:size(Gaussians,2));
        % Var=reshape(Var', 1, size(Var,1)*size(Var,2))';
        % 
        % tic;
        % yfit = zeros(size(classificationData,1),size(Gaussians,1));
        % for ex=1:size(classificationData,1) % Loop through all examples
        %     exToClassify=repmat(classificationData(ex,:),1,numLoc)';
        % 
        % 
        %     exResults = normpdf(exToClassify, Mean, Var);
        % 
        %     %exResults(Var==0 & exToClassify==Mean)=normpdf(-95,-95,1);
        %     exResults(Var==0 & exToClassify==Mean)=1;
        %     exResults(Var==0 & exToClassify~=Mean)=0.00001;
        %     exResults(exToClassify==-100)=1;
        %     %exResults(Mean==-100)=1;                
        % 
        % 
        %     exResults(exResults<0.00001)=0.00001;
        %     exResults = reshape(exResults,params,numLoc)';
        %     yfit(ex,:)=prod(exResults,2)';
        % end
        % 
        % % Normalize weights
        % for i=1:size(yfit,1) 
        %     yfit(i,:)=yfit(i,:)./sum(yfit(i,:));
        % end
        % 
        % scores2 = repmat(yfit,2,1);
        % 
        % scores3=[];
        % for k=1:size(scores2,1)/2
        %     scores3=[scores3; scores2(k:size(scores,1):size(scores2,1),:)];
        % end
        % 
        % cartesianLabels2=repmat(cartesianLabels,1,size(scores,1));
        % 
        % C=dot(scores3',cartesianLabels2);
        % 
        % yfit = reshape(C, 2, size(C,2)/2)';
        % 
        % D=0.3048*sqrt(sum((yfit-classificationLabels).^2,2));
        % gaussianProcessGaussianMixture = mean(D) 
        % 
        % var=size(gdiErrorPlotY,1)+1;
        % for i=1:ceil(max(D))*4+1
        %     gdiErrorPlotY(var,i)=sum(D<=0.25*(i-1))/size(classificationLabels,1);
        % end
        % 
        % % Clean up array to remove extra zeros
        % for i=1:size(gdiErrorPlotY,1)
        %     indices = find(gdiErrorPlotY(i,:)==1);
        %     gdiErrorPlotY(i,indices(size(indices,2)):size(gdiErrorPlotY,2))=1;
        % end
        % 
        % hold on
        % 
        % gdiErrorPlotX = 0:0.25:(size(gdiErrorPlotY,2)-1)/4;
        % 
        % % If we only have one dataset
        % if(size(gdiErrorPlotY,1)==1)
        %     plot(gdiErrorPlotX, gdiErrorPlotY, 'c');
        % else
        %     plot(gdiErrorPlotX, mean(gdiErrorPlotY), 'c');
        % end

        %% SVM GMM Regression
        % yfit=[];
        % numLoc=size(cartesianLabels,1);
        % 
        % [ypred,maxi,yfit] = svmmultival(classificationData,xsup,w,b,nbsv,kernel,kerneloption);
        % 
        % % Normalize weights
        % for i=1:size(yfit,1) 
        %     yfit(i,:)-min(yfit(i,:));
        %     yfit(i,:)=yfit(i,:)./sum(yfit(i,:));
        % end
        % scores2 = repmat(yfit,2,1);
        % 
        % scores3=[];
        % for k=1:size(scores2,1)/2
        %     scores3=[scores3; scores2(k:size(scores,1):size(scores2,1),:)];
        % end
        % 
        % cartesianLabels2=repmat(cartesianLabels,1,size(scores,1));
        % 
        % C=dot(scores3',cartesianLabels2);
        % 
        % yfit = reshape(C, 2, size(C,2)/2)';
        % 
        % D=0.3048*sqrt(sum((yfit-classificationLabels).^2,2));
        % gaussianProcess_SVM = mean(D)
        % 
        % var=size(gdiErrorPlotY,1)+1;
        % for i=1:ceil(max(D))*4+1
        %     gdiErrorPlotY(var,i)=sum(D<=0.25*(i-1))/size(classificationLabels,1);
        % end
        % 
        % % Clean up array to remove extra zeros
        % for i=1:size(gdiErrorPlotY,1)
        %     indices = find(gdiErrorPlotY(i,:)==1);
        %     gdiErrorPlotY(i,indices(size(indices,2)):size(gdiErrorPlotY,2))=1;
        % end
        % 
        % hold on
        % 
        % gdiErrorPlotX = 0:0.25:(size(gdiErrorPlotY,2)-1)/4;
        % 
        % % If we only have one dataset
        % if(size(gdiErrorPlotY,1)==1)
        %     plot(gdiErrorPlotX, gdiErrorPlotY, 'c');
        % else
        %     plot(gdiErrorPlotX, mean(gdiErrorPlotY), 'c');
        % end

        %% NNS GMM Regression
        yfit=[];
        numLoc=size(cartesianLabels,1);

        [IDX D] = knnsearch(trainingData,classificationData,'K',100,'Distance','cosine');

        yfitX=[];
        yfitY=[];
        for i=1:size(IDX,1)
            tic
            [yPredicted, scores] = predict(rForest, classificationData(i,:));

            % Set up the means of each Gaussian
            mu=cartesianLabels(scores(1,:)>0,:);

            % Setup the Sigma of each Gaussian
            sigma=[];
            for s=1:size(mu,1)
                sigma(:,:,s) = 1.5*eye(2);
            end

            % Setup the mixture proportions of each Gaussian
            p=scores(1,scores(1,:)>0);

            GMM = gmdistribution(mu,sigma,p);
            
            yfitX=cartesianLabels(trainingLabels(IDX(i,:)),1);
            yfitY=cartesianLabels(trainingLabels(IDX(i,:)),2);

            Wt = pdf(GMM, [yfitX yfitY]);
            Wt = Wt./sum(Wt);

            yfitX=yfitX.*Wt;
            yfitY=yfitY.*Wt;
            yfit(i,:)=[sum(yfitX) sum(yfitY)];
            Timing(IDX)=toc;
            
        end

        D=0.3048*sqrt(sum((yfit-classificationLabels).^2,2));
        gmm_NN(n,k) = mean(D);
        % 
        % var=size(gdiErrorPlotY,1)+1;
        % for i=1:ceil(max(D))*4+1
        %     gdiErrorPlotY(var,i)=sum(D<=0.25*(i-1))/size(classificationLabels,1);
        % end
        % 
        % % Clean up array to remove extra zeros
        % for i=1:size(gdiErrorPlotY,1)
        %     indices = find(gdiErrorPlotY(i,:)==1);
        %     gdiErrorPlotY(i,indices(size(indices,2)):size(gdiErrorPlotY,2))=1;
        % end
        % 
        % hold on
        % 
        % gdiErrorPlotX = 0:0.25:(size(gdiErrorPlotY,2)-1)/4;
        % 
        % % If we only have one dataset
        % if(size(gdiErrorPlotY,1)==1)
        %     plot(gdiErrorPlotX, gdiErrorPlotY, 'r');
        % else
        %     plot(gdiErrorPlotX, mean(gdiErrorPlotY), 'r');
        % end

        %% Compute Better"ness"
        %betterBy=1-gaussianProcessRF/classificationOnly_RForest

        % gdiErrorPlotX=[];
        % gdiErrorPlotY=[];
        % 
        % [yPredicted, scores] = predict(rForest, classificationData);
        % yfit = zeros(size(yPredicted,1),2);
        % 
        % 
        % for example=1:size(yfit,1)
        %     predictedData = [cartesianLabels(:,1) cartesianLabels(:,2) scores(example,:)'];
        % 
        %     % Remove data points with 0 probability and sort by probabilities
        %     predictedData = predictedData(predictedData(:,3)~=0,:);
        %     [Y I]=sort(predictedData(:,3),'descend');
        %     predictedData = predictedData(I,:);
        % 
        %     IDX = kmeans(predictedData(:,1:2),ceil(size(predictedData,1)/2),'EmptyAction', 'singleton');
        %     s = SplitVec(IDX);
        % 
        %     % Find a consecutive cluster of at least consCluster
        %     consClusterSize=2;
        %     consClusterStart=1;
        %     for l=1:size(s,1)
        %         if(size(s{l},1)<consClusterSize)
        %             consClusterStart = consClusterStart + size(s{l},1);
        %         else
        %             break;
        %         end
        %     end
        %     consClusterEnd=consClusterStart+size(s{l},1)-1;
        % 
        % 
        %     % Potential check: make sure that the probabilities of the consecutive 
        %     % cluster is greater than those of the (single) highest probability
        %     if(consClusterStart==size(predictedData,1)+1)
        %         yfit(example,1)=dot(predictedData(:,1),predictedData(:,3));
        %         yfit(example,2)=dot(predictedData(:,2),predictedData(:,3));
        %     elseif(sum(predictedData(consClusterStart:1:consClusterEnd,3))>predictedData(1,3))
        %         % Get only the data we care about and normalize it
        %         predictedData=predictedData(consClusterStart:1:consClusterEnd,:);
        %         predictedData(:,3)=predictedData(:,3)./sum(predictedData(:,3));
        %         
        %         
        %         yfit(example,1)=dot(predictedData(:,1),predictedData(:,3));
        %         yfit(example,2)=dot(predictedData(:,2),predictedData(:,3));
        %     else
        %         yfit(example,1)=dot(predictedData(:,1),predictedData(:,3));
        %         yfit(example,2)=dot(predictedData(:,2),predictedData(:,3));
        %     end
        %     
        % end
        %  
        % D=0.3048*sqrt(sum((yfit-classificationLabels).^2,2));
        % 
        % mean(D)
        % 
        % var=size(gdiErrorPlotY,1)+1;
        % for i=1:ceil(max(D))*4+1
        %     gdiErrorPlotY(var,i)=sum(D<=0.25*(i-1))/size(classificationLabels,1);
        % end
        % 
        % % Clean up array to remove extra zeros
        % for i=1:size(gdiErrorPlotY,1)
        %     indices = find(gdiErrorPlotY(i,:)==1);
        %     gdiErrorPlotY(i,indices(size(indices,2)):size(gdiErrorPlotY,2))=1;
        % end
        % 
        % hold on
        % 
        % gdiErrorPlotX = 0:0.25:(size(gdiErrorPlotY,2)-1)/4;
        % 
        % % If we only have one dataset
        % if(size(gdiErrorPlotY,1)==1)
        %     plot(gdiErrorPlotX, gdiErrorPlotY, 'm');
        % else
        %     plot(gdiErrorPlotX, mean(gdiErrorPlotY), 'm');
        % end
        % 
        % 
        % 
        % gdiErrorPlotX=[];
        % gdiErrorPlotY=[];
        % 
        % [yPredicted, scores] = predict(rForest, classificationData);
        % yfit = zeros(size(yPredicted,1),2);
        % 
        % 
        % for example=1:size(yfit,1)
        %     predictedData = [cartesianLabels(:,1) cartesianLabels(:,2) scores(example,:)'];
        % 
        %     % Remove data points with 0 probability and sort by probabilities
        %     predictedData = predictedData(predictedData(:,3)~=0,:);
        %     [Y I]=sort(predictedData(:,3),'descend');
        %     predictedData = predictedData(I,:);
        % 
        %     numClusters = 2;
        %     IDX = kmeans(predictedData(:,1:2),numClusters,'EmptyAction', 'singleton');
        %     
        %     % Choose the cluster with highest probability
        %     chosenCluster = 0;
        %     maxClusterWeight = 0;
        %     for clust=1:numClusters
        %         if(sum(predictedData(IDX==clust,3))>maxClusterWeight)
        %             chosenCluster=clust;
        %             maxClusterWeight = sum(predictedData(IDX==clust,3));
        %         end 
        %     end
        %     
        %     predictedData=predictedData(IDX==chosenCluster,:);
        %         
        %     yfit(example,1)=dot(predictedData(:,1),predictedData(:,3));
        %     yfit(example,2)=dot(predictedData(:,2),predictedData(:,3));
        %     
        % end
        %  
        % D=0.3048*sqrt(sum((yfit-classificationLabels).^2,2));
        % 
        % mean(D)
        % 
        % var=size(gdiErrorPlotY,1)+1;
        % for i=1:ceil(max(D))*4+1
        %     gdiErrorPlotY(var,i)=sum(D<=0.25*(i-1))/size(classificationLabels,1);
        % end
        % 
        % % Clean up array to remove extra zeros
        % for i=1:size(gdiErrorPlotY,1)
        %     indices = find(gdiErrorPlotY(i,:)==1);
        %     gdiErrorPlotY(i,indices(size(indices,2)):size(gdiErrorPlotY,2))=1;
        % end
        % 
        % hold on
        % 
        % gdiErrorPlotX = 0:0.25:(size(gdiErrorPlotY,2)-1)/4;
        % 
        % % If we only have one dataset
        % if(size(gdiErrorPlotY,1)==1)
        %     plot(gdiErrorPlotX, gdiErrorPlotY, 'y');
        % else
        %     plot(gdiErrorPlotX, mean(gdiErrorPlotY), 'y');
        % end
    end
end

% save('RegressionResults2.mat', 'classificationOnly_RForest', 'classificationOnly_Gaussian', 'classificationOnly_SVM', 'classificationOnly_NNS', 'gmm_RF', 'gmm_NN');
